package cypher;

public interface Constants {

  /*----------------------------------------------------------------------------}
  {- some constants used by Cypher
  {- all variables implicitly public static final, but explicitly declared. :)
  {- most of these (if not all) are taken from G's java server code.
  {----------------------------------------------------------------------------*/

  public static final int PORT = 8000;  // Port number of server
  public static final String SERVERHOST = new String("143.167.132.155");   // Host address
  public static final String BABEL_HTTP = new String("http://143.167.132.155:81/?SETCOOKIE=");
  public static final int MAX_INP = 512;
  public static final int MAX_MSG  = 1023;
  public static final String VERSION="1.2.4";
  public static final String VERSION_INFO = "J1"+VERSION;

  
  /*----------------------------------------------------------------------------}
  {- some constants used for maths. :)
  {----------------------------------------------------------------------------*/
  public static final int W_LOGIN_PACKET = 16;
  public static final int W_PERSON = 512;
  public static final int W_IP_ADDRESS = 16;
  public static final int W_CLIENT_USERLIST = 154;

  /*----------------------------------------------------------------------------}
  {- commands for the DataHeader
  {----------------------------------------------------------------------------*/
  public static final int C_SYSTEM = 0;
  public static final int C_HELLO = 1;
  public static final int C_PING_REQ = 2;
  public static final int C_PING_REPLY = 3;
  public static final int C_LOGIN = 4;
  public static final int C_LOGOUT = 5;
  public static final int C_USERLIST = 6;
  public static final int C_USER_CREATE =7;
  public static final int C_USER_GET = 8;
  public static final int C_USER_PUT = 9;
  public static final int C_USER_EXIST = 10;
  public static final int C_MSG_SEND = 11;
  public static final int C_STATUS_SET = 12;


  public static final int C_MSG_GET = 21;
  public static final int C_SET_COOKIE = 22;
  public static final int C_USER_ZAP = 23;
  public static final int C_USER_BB = 24;
  public static final int C_USER_REGISTER = 25;
  public static final int C_USER_PUT_AND_MAIL = 26;


  public static final int C_CONF = 50;
  public static final int C_CHAT = 51;
  public static final int C_CONF_ROOM = 52;

  /*----------------------------------------------------------------------------}
	{- File system commands.
  {----------------------------------------------------------------------------*/
	public static final int C_FOLDER_CREATE = 60;
	public static final int C_FOLDER_DIRGET = 61;
	public static final int C_FOLDER_PEOPLEGET = 62;
	public static final int C_FOLDER_PEOPLESET = 63;

	public static final int C_FILE_DISCUSSIONCREATE = 64;
	public static final int C_FILE_UPLOAD = 65;
	public static final int C_FILE_GET = 66;

	public static final int C_FILE_POSTADD = 67;
	public static final int C_FILE_POSTDEL = 68;
	public static final int C_FILE_OPTIONSSET = 69;
	public static final int C_FILE_OPTIONSGET = 70;

	public static final int C_MAIL_SEND = 71;
	public static final int C_MAIL_GET = 72;

	public static final int C_FILE_RENAME = 73;
	public static final int C_FILE_DELETE = 74;
	public static final int C_FILE_ARCHIVE = 75;

	public static final int C_FOLDER_GROUPACCESSSET = 76;
	public static final int C_FOLDER_GROUPACCESSGET = 77;

	public static final int C_MAIL_DELETE = 78;
	public static final int C_MAIL_ALL = 79;
	public static final int C_SERVER_CLOSE = 80;
	public static final int C_SERVER_DOWN = 81;
	public static final int C_SERVER_REOPEN = 82;

	public static final int C_MAIL_SEND_WEBSERVER = 84;

	public static final int C_STATUS_INFO = 85;

	public static final int C_LOG_QUERY = 86;

	public static final int C_WATCH_LOGIN = 90;

	public static final int C_URL = 95;
	public static final int C_WEB_FILE_MAKE = 96;

	public static final int C_FOLDER_DIRGET2 = 99;
	public static final int C_USERLIST_NEW = 100;
	public static final int C_SERVER_INFO = 101;
	public static final int C_REGISTER_NEW = 102;
	public static final int C_WEBSERV_LIST = 103;
	public static final int C_STARTUP_ENQ = 104;
	public static final int C_LAST20 = 105;

	public static final int C_USER_BAN = 106;
	public static final int C_USER_UNBAN = 107;

	public static final int C_USER_SEARCH = 108;

	public static final int C_CALLBBSCOMMAND = 110;  // added 26/1/98

	public static final int C_WIPE_MOTD_URF = 120;   // added PT 26/1/98


   /*----------------------------------------------------------------------------}
   {- possible command parameters
   {----------------------------------------------------------------------------*/
    public static final int P_OK = 1;
    public static final int P_NOPRIVS = 254;
    public static final int P_ERROR = 255;
    public static final int P_CHAT_REQ = 2;
    public static final int P_CHAT_ACK = 3;
    public static final int P_CHAT_NACCEPT = 4;
    public static final int P_CHAT_NOREC = 5;
    public static final int P_NLOGIN_BAD_LOGIN = 2;
    public static final int P_NLOGIN_BAD_LOGINS = 3;
    public static final int P_NLOGIN_BANNED = 4;
    public static final int P_NLOGIN_BANNEDIP = 5;
    public static final int P_NLOGIN_SERVERCLOSED = 6;
    public static final int P_OK_BUTSERVERCLOSED = 7;
    public static final int P_OK_BUT_CLIENT_IS_OLD = 8;
    public static final int P_OK_BUT_NO_WEB = 9;
    public static final int P_ALREADY_LOGGED_IN = 10;
    public static final int P_LOGOUT_SERVER_DOWN = 3;
    public static final int P_LOGOUT_TIMEOUT = 4;
    public static final int P_LOGOUT_ZAP = 5;
    public static final int P_LOGOUT_USER_REQUEST = 6;
    public static final int P_USER_EXIST = 2;
    public static final int P_USER_NEXIST = 3;
    public static final int P_USER_BAD_NAME = 16;
    public static final int P_USER_BAD_EMAIL = 32;

    public static final int P_REG_ENQ = 2;     // WHO'S IN THE Q?
	public static final int P_REG_NOREGS = 3;  // NO REGISTRATIONS PENDING
	public static final int P_REG_CONF = 4;    // CONFIRM
	public static final int P_REG_DEFER = 5;   // DEFER REGISTRATION
	public static final int P_REG_DELETE = 6;  // DELETE REGISTRATION
	public static final int P_REG_NEW = 7;     // NEW USER REGISTRATION (from client)
	public static final int P_REG_SECOND = 8;  // TWO REGISTRATIONS AT ONCE
	public static final int P_REG_CLEAR_Q = 9; // SET ALL PENDING TO QUEUED
	public static final int P_REG_CONVERT_TO_PENDING = 10; // Leave user there for the moment
	public static final int P_REG_BAD_USERNAME = 11;       // Send standard bad username email
	public static final int P_REG_BAD_EMAIL = 12;          // Send standard bad email address email
	public static final int P_REG_BAD_REALNAME = 13;       // Send standard bad realname email

	//Rem P_OK is 1 i think
	public static final int P_REGISTER_BAD_USERNAME = 2;
	public static final int P_REGISTER_NO_EMAIL = 4;
	public static final int P_REGISTER_NO_CITY = 8;
	public static final int P_REGISTER_BAD_EMAIL = 16;
	public static final int P_REGISTER_NO_REALNAME = 32;
	public static final int P_REGISTER_NO_USERNAME = 64;
	public static final int P_REGISTER_USER_EXISTS = 128;
	//public static final int P_REGISTER_ = 128

	public static final int P_MSG_BAD_CON = 2;
	public static final int P_MSG_INVIS = 3;
	public static final int P_MSG_ALL = 4;
	public static final int P_MSG_SYS = 5;
	public static final int P_MSG_SYS_SHEF = 6;
	//public static final int P_STATUS_NOPRIVS = 2

    /*----------------------------------------------------------------------------}
    {- Conferencer Constants
    {----------------------------------------------------------------------------*/
	public static final int P_CC_ENTER = 2;
	public static final int P_CC_EXIT = 3;
	public static final int P_CC_SAY = 4;
	public static final int P_CC_EMOTE = 5;
	public static final int P_CC_SHOUT = 6;
	public static final int P_CC_POLICE = 7;
	public static final int P_CC_ECHO = 8;
	public static final int P_CC_ECHOALL = 9;
	public static final int P_CC_TELL = 10;
	public static final int P_CC_GOTO = 11;
	public static final int P_CC_KICK = 12;
	public static final int P_CC_USERLIST = 13;
	public static final int P_CC_INVITE = 14;
	public static final int P_CC_ACCEPT = 15;
	public static final int P_CC_HIDE = 17;
	public static final int P_CC_REVEAL = 18;
	public static final int P_CC_BAN = 19;
	public static final int P_CC_GAG = 20;
	public static final int P_CC_LOOK = 21;
	public static final int P_CC_SYS = 22;
	public static final int P_CC_ZAP = 23;
	public static final int P_CC_TRAP = 24;
	public static final int P_CC_REMOVE = 25;
	public static final int P_CC_MONITOR = 26;
	public static final int P_CC_MAINROOM = 27;
	public static final int P_CC_SUMMON = 28;
	public static final int P_CC_CHECK = 29;
	public static final int P_CC_ROOMUSERS = 30; // who the user can see when entering a room
	public static final int P_CC_WIBBLE = 101;   // hard coding
	public static final int P_CC_ELMER = 102;    //        moi?
	public static final int P_CC_ERROR = 254;    // used to send errors back to client

	public static final int P_CC_FLAG_ONCC = 1;
	public static final int P_CC_FLAG_GAG = 2;
	public static final int P_CC_FLAG_TRAP = 4;
	public static final int P_CC_FLAG_MONITOR = 8;
	public static final int P_CC_FLAG_ELMER = 16;
	public static final int P_CC_FLAG_WIBBLE = 32;
	public static final int P_CC_FLAG_SPARE = 64;
	public static final int P_CC_FLAG_PRIVATE = 128;

	public static final int P_CC_VIS_SAME_ROOM = 1;
	public static final int P_CC_VIS_GLOBAL = 2;

  /*----------------------------------------------------------------------------}
   {- other constants added from BBSConstants.java 22/02/2001
   {----------------------------------------------------------------------------*/

	//Rem Structure Constants
	public static final int W_USERNAME = 16;
	public static final int W_PASSWORD = 16;
	public static final int W_EMAIL = 64;
	public static final int W_MOTTO = 64;
	public static final int W_REALNAME = 32;
	public static final int W_CITY = 16;
	public static final int W_COMMENT = 200;
	public static final int W_COOKIE = 16;
	public static final int W_HEADER = 8;
	public static final int W_MAX_DIR_LEN = 240;
	public static final int W_MAX_POST_LEN = 5000;

	// Group constants
    public static final int G_REGISTERED = 1;
    public static final int G_BM = 2;	
    public static final int G_AUTHOR = 4;
    public static final int G_GUIDE = 8;
    public static final int G_CC_POLICE = 16;
    public static final int G_EXEC = 32;
    public static final int G_SECTION_MANAGER = 64;

    public static final int X_MSG = 1;
    public static final int X_REGISTER_USERS = 2;
    public static final int X_FILE_READ = 4;
    public static final int X_FILE_ADD = 8;
    public static final int X_EXAMINE = 16;
    public static final int X_EXAMINE_HIDDEN = 32;
    public static final int X_CHAT = 64;
    public static final int X_CC_ENTER = 128;
    public static final int X_CC_POLICE = 256;
    public static final int X_IGNORE_FILE_PERMISSIONS = 512;
    public static final int X_ZAP = 1024;
    public static final int X_BB = 2048;
    public static final int X_MAIL_SEND = 4098;
    public static final int X_FORCE_SEND = 8192;
    public static final int X_CHANGE_USER_DETAILS = 16384;
    public static final int X_DOWN_SERVER = 32768;
    public static final int X_CLOSE_SERVER = 65536;
    public static final int X_RESTART_SERVER = 131072;
    public static final int X_EDIT_ALL_POSTINGS = 262144;
    public static final int X_GENERATE_LOG_EXTRACT = 524288;
    public static final int X_EDIT_CC_ROOMS = 1048576;
    public static final int X_INVIS_LOGIN = 2097152;
    public static final int X_SEE_INVIS = 4194304;
    public static final int X_CHANGE_VIS_ALL = 8388608;

  
	public static final String STATUS_ACTIVE = "A";
	public static final String STATUS_BANNED = "B";
	public static final String STATUS_DELETED = "D";
	public static final String STATUS_SECONDACC = "S";
	public static final String STATUS_REGQUEUE = "Q";
	public static final String STATUS_PENDING = "P";
	public static final String STATUS_WEBSERVER = "W";

	//Rem display constants
	public static final int D_LASTON = 32;
	public static final int D_CREATED = 16;
	public static final int D_REALNAME = 8;
	public static final int D_EMAIL = 4;
	public static final int D_HOMECITY = 2;
	public static final int D_PRIVS = 1;

	//Rem UDB Fields (Person Structure)
	public static final int U_USER_ID = 1;
	public static final int U_CREATED = 2;
	public static final int U_LAST_ON = 3;
	public static final int U_USERNAME = 4;
	public static final int U_PASSWORD = 5;
	public static final int U_EMAIL = 6;
	public static final int U_PRIVS = 7;
	public static final int U_BANNED_UNTIL = 8;
	public static final int U_DETAILS = 9;
	public static final int U_POPNAME = 10;
	public static final int U_REALNAME = 11;
	public static final int U_CITY = 12;
	public static final int U_COMMENT = 13;
	public static final int U_PREVPOSTINGS = 14;
	public static final int U_GROUP = 15;
	public static final int U_CONTROL = 16;
	public static final int U_STATUS = 17;

    // Priv Constants
	public static final int S_AUTHOR = 1073741824;  //0x40000000
	public static final int S_EXECBM = 536870912;    //0x20000000 // SYSOP
	public static final int S_BM = 268435456; //0x10000000 // SYSADMIN
	public static final int S_GUIDE = 134217728;    //0x8000000
	public static final int S_REGISTERED = 67108864;//0x4000000
	public static final int S_ULTRAINVIS_LOGIN = 33554432;//0x2000000
	public static final int S_INVIS_LOGIN = 8388608;
	public static final int S_CC_POLICE = 2097152;
	public static final int S_CC_INVIS_LOGIN = 1048576;
	public static final int S_ON_CONFERENCER = 65536;
	public static final int S_SECT_MAN = 8192;
	public static final int S_EXTERNAL_ACCESS = 4096;
	public static final int S_EXEC = 2048;
	public static final int S_CC_BANNED = 1024;
	public static final int S_FILE_ADD = 512;
	public static final int S_FILE_READ = 256;
	public static final int S_CHAT_INVITE = 128;
	public static final int S_CHAT_RECEIVE = 64;
	public static final int S_CC_INVITE = 32;
	public static final int S_CC_RECEIVE = 16;
	public static final int S_MAIL_SEND = 8;
	public static final int S_MAIL_RECEIVE = 4;
	public static final int S_MESSAGE_SEND = 2;
	public static final int S_MESSAGE_RECEIVE = 1;

  // mouse constants

  public static final int M_BB=1004;
  public static final int M_CHAT=1007;
  public static final int M_EXAMINE=1012;
  public static final int M_INVIS=1015;
  public static final int M_INVIS_OFF=1016;
  public static final int M_INVIS_ON=1017;
  public static final int M_PINGUSER=1024;  
  public static final int M_SEND=1031;
  public static final int M_SENDMAIL=1032;
  public static final int M_ULTRAINVIS=1035;
  public static final int M_ULTRA_OFF=1036;
  public static final int M_ULTRA_ON=1037;
  public static final int M_ZAP=1041;  
}