/*-----------------------------------------------------------------------------}
{- [CYPHER]
{-
{- @AUTHOR Phil Wilson pipthepixie@bodacious.co.uk
{- @DATE 19/04/2001
{-
{- for updates - check http://pipthepixie.tripod.com/cypher/
{-
{- a java client for babel (http://babel.shef.ac.uk) that should be a whole lot
{- better than either of the current ones (i.e. - work).
{- As far as possible, I've tried to keep the GUI and networking code separate
{- so as to make for easy updates in the future.
{- Of course, if it's really necessary, it's possible to just use the command
{- line version of this client (which is what this is based around), to build a
{- new GUI from scratch.
{-
{- CODE:        I've tried to comment most of it, so it should be fairly clear. :)
{-              All the files that create GUI screens are xxxFrame.java (and the
{-              about box...). The rest are all that's needed for processing of
{-              data coming in from or going out to the babel server.
{-              6/5/2001 - watch list is handled in mainFrame.java
{-
{- CURRENT BUGS:font sizes under *nix are screwed. not sure why. ideas?
{-
{- IDEAS:       keep a send message window in memory to speed up program? current
{-              java clients take fucking ages to put a send message window on
{-              the screen on unix boxes here in germany.
{-
{-              Write the code to record messages from each user in a vector
{-              with optional save conversation (GUI).
{-
{-              Add a "userlist redrawn TIME" to status bar, just to let user
{-              know if maybe they should get a new one. :)
{-
{-              Change the saved file names to non extension (i.e. DEBUG, WATCH)
{-
{-              Change the userlist to vector to array?
{-               - not sure about this any more. it would be faster access....
{-
{- NOTE: this edition does not carry support for the early b2 specification
{- because there's literally no point whatsoever. it is, however, crazily easy
{- to change this code to support B2. A proper B2 version will be released as
{- soon as TyRaNiD and Matt actually work out how the server's going to handle
{- channels. :)
{-----------------------------------------------------------------------------*/


package cypher;

import javax.swing.*;
import java.awt.*;
import java.io.*;
import java.util.*;
import java.net.*;

public class Cypher implements Constants {
  static boolean packFrame = false;
  private static OutputStreamWriter DEBUGSTREAM; // stream to the DEBUG file
  private static int ERR=0;            // see if we're allowed to write DEBUG info
  public static Socket bSocket;        // the basic socket to babel
//  public static Socket bbsSocket;       // the socket to the BBS.
  public static String BROWSER_PATH = null;
  public static DataInputStream in;    // the incoming stream from the socket
  public static DataOutputStream out;  // the outgoing stream to the socket
  public static User spod=new User();  // you, the user!
  public static int AFK = 0;           // away from computer flag.
  public static Vector userList = new Vector(10,2); // full userlist for listusers
  public static Vector userNames = new Vector(10,2); // vector of usernames for combo-boxes.

  //Construct the GUI
  public Cypher() {
    mainFrame frame = new mainFrame();
    if (packFrame)
      frame.pack();
    else
      frame.validate();
    //Centre the window
    Dimension screenSize = Toolkit.getDefaultToolkit().getScreenSize();
    Dimension frameSize = frame.getSize();
    if (frameSize.height > screenSize.height) frameSize.height = screenSize.height;
    if (frameSize.width > screenSize.width) frameSize.width = screenSize.width;
    frame.setLocation((screenSize.width - frameSize.width) / 2, (screenSize.height - frameSize.height) / 2);
    frame.setVisible(true);
  }

  // draws the login screen
  public static void Login(){
    loginFrame frame = new loginFrame();
    if (packFrame)
      frame.pack();
    else
      frame.validate();
    //Centre the window
    Dimension screenSize = Toolkit.getDefaultToolkit().getScreenSize();
    Dimension frameSize = frame.getSize();
    if (frameSize.height > screenSize.height) frameSize.height = screenSize.height;
    if (frameSize.width > screenSize.width) frameSize.width = screenSize.width;
    frame.setLocation((screenSize.width - frameSize.width) / 2, (screenSize.height - frameSize.height) / 2);
    frame.setVisible(true);
  }

  // OK, so i finally caved in on 2/5/2001 and made the line break non Unix-stylee. bah.
  public static void DEBUG(String message) {
    if (ERR==0) {
      try {
        DEBUGSTREAM.write(Utils.getDate()+" - "+message+System.getProperty("line.separator"));
        DEBUGSTREAM.flush();
        if (message.equalsIgnoreCase("END")) DEBUGSTREAM.close();        
      } catch (IOException eDEBUG){
         ERR=1;
         System.out.println("ERROR WRITING TO DEBUG FILE"+message);
         System.out.println("DEBUG recording has been stopped");
         System.out.println(eDEBUG);
      }
    }else {
      System.out.println("ERROR: "+message);
    }
  }

  public static void DEBUG(Exception eMessage) {
    if (ERR==0) {
      try {
        DEBUGSTREAM.write(Utils.getDate()+" - "+eMessage+System.getProperty("line.separator"));
        DEBUGSTREAM.flush();
      } catch (IOException eDEBUG){
         ERR=1;
         System.out.println("ERROR WRITING TO DEBUG FILE"+eMessage);
         System.out.println("DEBUG recording has been stopped");
         System.out.println(eDEBUG);
      }
    }else {
      System.out.println("ERROR: "+eMessage);
    }
  }

//Main method
public static void main(String[] args) {
{
  try { // try1
    /*----------------------------------------------------------------------------}
    {- open the initial socket, open streams to write to and from, and then
    {- make sure we get a C_HELLO from the server
    {----------------------------------------------------------------------------*/
      try {
        DEBUGSTREAM = new OutputStreamWriter(new FileOutputStream("DEBUG.TXT", true));
      } catch(Exception eDEBUG){
        File filename = new File("DEBUG.TXT");
        if (!filename.exists()) System.out.println("Could not create a DEBUG file");
        else System.out.println("Could not open the DEBUG file. No logging. Sorry.");
      }

      DEBUG("***** CYPHER STARTED *****");
      DEBUG("Checking for server presence....");
      bSocket = new Socket(SERVERHOST, PORT);
      try { // try2
        String Username = "";
        String Password = "";
        in = new DataInputStream(bSocket.getInputStream());
        out = new DataOutputStream(bSocket.getOutputStream());
        Comms.check_server(in);

        /*----------------------------------------------------------------------------}
        {- Declare a listening thread, receive the user
        {- details, and start a thread which listens to the instream.
        {- pass control back to user and wait for input.
        {----------------------------------------------------------------------------*/

        Thread reader = new Thread() {

        public void run() {
          try {
            DataHeader hed=new DataHeader();
            byte[] buffer=new byte[0];
            while (true) {
              try {
                hed.recv(in);
                buffer = new byte[hed.getPacketSize()];
                in.readFully(buffer);
                Comms.dataReady(hed, buffer);
              }
				      catch (SocketException eSocket) {
                // this will always throw an error until i know how to do a stop() on this thread.
                /*
                Cypher.DEBUG("Error in socket: ");
                Cypher.DEBUG(eSocket);
                */
  				    }
            }
          }
          catch (IOException eAvailable) {
            // this should only crop up if we've been disconnected unexpectedly.
            Cypher.DEBUG("Error in Reader. Stream not available?");
            Cypher.DEBUG(eAvailable);
          }
          catch (Exception eGeneral) {
            Cypher.DEBUG("Reader error :");
            Cypher.DEBUG(eGeneral);
          }
        }//end run
        };// end Thread declaration

        reader.setPriority(Thread.currentThread().getPriority()+1);
        reader.start();
        try {
          // can't use Windoze look and feel because of togglebuttons.
          UIManager.setLookAndFeel(UIManager.getCrossPlatformLookAndFeelClassName());
        }
        catch(Exception eLAF){
          Cypher.DEBUG("Couldn't initialise Look and Feel");
          Cypher.DEBUG(eLAF);
        }

        /*----------------------------------------------------------------------------}
        {- now go and get the username and password!
        {----------------------------------------------------------------------------*/
        Login();
      } // end try2
      catch (IOException eStream) {
        Cypher.DEBUG(eStream);
        Cypher.DEBUG("Error creating streams to server.");
      }
    } // end try1
    catch(IOException eSock) {
      Cypher.DEBUG("failed");
      Cypher.DEBUG("Unable to create socket to server.");
      errorFrame.show("The server isn't available at the moment.\nWait a few minutes then try again.","Could not connect to Babel");
      System.exit(0);
    }
}
} // end main
} // end class
