/*----------------------------------------------------------------------------}
{- the file that handles user input.
{-
{- this file contains: 
{-
{- logOut()
{- Send(String username, String message, int SYS)
{- showUserlist()
{- Examine(String target)
{- goInvis()
{- doPing()
{- changePopname()
{- showStatus()
{- doZap()
{- goUltraInvis()
{- bMail()
{----------------------------------------------------------------------------*/

package cypher;

import java.io.*;
import java.net.*;
import cypher.Cypher.*;
import cypher.mainFrame;

public class Input implements Constants
{
  public static void logOut()
  {
    try {
      // STILL need to stop the reader thread.
      Cypher.in.close();
      Cypher.out.close();
      Cypher.bSocket.close();
      Cypher.DEBUG("streams have been closed. [cypher] session has ended.");
      Cypher.DEBUG("<-- end the thread!!! -->");
      Cypher.DEBUG("logging you out..");
      Cypher.DEBUG("******** FINISHED ********");
      Cypher.DEBUG("END");//STREAM.close();
      System.exit(0);
    }
    catch (Exception eLogout) {
      Cypher.DEBUG("Error trying to log out.");
      Cypher.DEBUG(eLogout);
    }
  }


  /*----------------------------------------------------------------------------}
  {- the send message function. posts off the request.
  {- If SYS is 1 then this is a system message.
  {----------------------------------------------------------------------------*/
  public static int Send(String toUser, String message, int SYS)
  {
    int check=0;
    int userID;
    char user;
    DataHeader sendHeader;
    try {
      user = (char)Cypher.spod.ConnectionNum;// send to self if it somehow fails.
      // sort out who to send it to
      if (SYS==0) {
        userID = Utils.NameToID(toUser);
        if (userID>0) {
          user = (char)userID;
        } else {
          Cypher.DEBUG("Unable to send to that user. Can't find connection number");
          check = 1; // i.e. message failure
        }
      } 
      else {
        user = (char)0; // i.e. this is a SYSTEM MESSAGE
      }

      // set up things to send
      if (check==0) {

        String messagePacket=user + message;
        int messagesize=messagePacket.length();
        if (SYS==0) sendHeader = new DataHeader(C_MSG_SEND,1,0,0,messagesize);
        else sendHeader = new DataHeader(C_MSG_SEND,0,P_MSG_SYS,0,messagesize);
        sendHeader.send(Cypher.out);
        Cypher.out.writeBytes(messagePacket);
        Cypher.out.flush();
        if (Cypher.AFK==1){Cypher.AFK=0;} //if AFK was set, unset it.
        return check; // message success
      }
    }
    catch (IOException eInput) {
      Cypher.DEBUG(eInput);
      Cypher.DEBUG("Error in Input/Output.");
    }
    catch (Exception eGeneral) {
      Cypher.DEBUG(eGeneral);
      Cypher.DEBUG("General error in send function.");
    }
    return check; // message failure
  }
  
  /*----------------------------------------------------------------------------}
  {- showUserlist() - get the users on the board, alphabetise them and display!
  {- this is a shitty sorting algorithm.
  {----------------------------------------------------------------------------*/
  public static void showUserlist()
  {
    // just request a new userlist from the server and deal with it in comms.java
    /*
    NewSpod tSpod = new NewSpod();
    NewSpod minSpod = new NewSpod();
    String[][] newList = new String[Cypher.userList.size()][2];

    for (int x=0; x < newList.length; x++)
    {
      tSpod = (NewSpod)Cypher.userList.elementAt(x);
      minSpod = tSpod;
      int min = Character.getNumericValue(tSpod.Username.charAt(0));
      for (int i=0; i < Cypher.userList.size(); i++) {
        tSpod = (NewSpod)Cypher.userList.elementAt(i);
        if (Character.getNumericValue(tSpod.Username.charAt(0)) < min)  {
          minSpod = tSpod; 
          min = Character.getNumericValue(tSpod.Username.charAt(0));
        }
      }
      newList[x][0] = Integer.toString(minSpod.ConID);
      newList[x][1] = minSpod.Username;
    }
    //Character.getNumericValue(newList[x].Username.charAt(0));

    for (int x=0; x < newList.length; x++) { 
      System.out.println(newList[x][0]+" - "+newList[x][1]);
    }*/
  }

  /*----------------------------------------------------------------------------}
  {- the examine user function. posts off the request.
  {- the return details are dealt with by the listener thread.
  {----------------------------------------------------------------------------*/  
  public static void Examine(String target)
  {
    try {
      Cypher.DEBUG("Examining: "+target);
      DataHeader examineHeader = new DataHeader(C_USER_GET, 0, 0, 0, target.length());
      examineHeader.send(Cypher.out);
      Cypher.out.writeBytes(target);
      Cypher.out.flush();
    }
    catch (IOException eExamine) {
      Cypher.DEBUG(eExamine);
      Cypher.DEBUG("Error doing Examine.");
    }
    catch (Exception eGeneral){
      Cypher.DEBUG(eGeneral);
      Cypher.DEBUG("General error in examine");
    }
  }


  /*----------------------------------------------------------------------------}
  {- @param conn: the connection number to change the visibility of.
  {----------------------------------------------------------------------------*/
  public static void goInvis(int conn)
  {
    try {
      int x=0;
      int invis; // default of invisible.
      int ultra; // default of ultravisible.
      DataHeader invisHeader;
      NewSpod thisuser = new NewSpod();

      while (thisuser.ConID!=conn) {
        thisuser=(NewSpod)Cypher.userList.elementAt(x);
        x++;
      }

      if (Utils.isI(thisuser.Privs)) invis=0; else invis = 1;
      if (Utils.isUI(thisuser.Privs)) ultra=1; else ultra = 0;

      invisHeader = new DataHeader(C_STATUS_SET, conn, invis, ultra, 0);

      invisHeader.send(Cypher.out);
      Cypher.DEBUG("Changed visibility");
    }
    catch (IOException eInvis) {
      Cypher.DEBUG(eInvis);
      Cypher.DEBUG("Error whilst changing visibility Status");
    }
  }


 /*----------------------------------------------------------------------------}
 {- Set a boolean variable that can be checked to see if the server sends us a 
 {- PING_REPLY so we know we are being answered. (just for user information)
 {----------------------------------------------------------------------------*/
  public static void doPing(int ConID)
  {
    try {
      DataHeader pingHeader = new DataHeader(C_PING_REQ, Cypher.spod.ConnectionNum, 0, 0, 0);
      pingHeader.send(Cypher.out);

      /*if (ConID==0)*/ Cypher.DEBUG("Pinging server");
      //else Cypher.DEBUG("Pinging "+Utils.IDToName(ConID));
    }
    catch (IOException ePingReq) {
      Cypher.DEBUG(ePingReq);
      Cypher.DEBUG("error whilst doing ping request");
    }
  }


  /*----------------------------------------------------------------------------}
  {- take in the user's popname from the popnameFrame, and set it!
  {- This function should also be available to BM's, so they can change a user's
  {- popname in case it's offensive? probably.
  {----------------------------------------------------------------------------*/
  public static void changePopname(String newpopname)
  {
    try {
      // last field empty for BM reason for changing popname of another user. yet to be
      // implemented.
      String popnameInfo = Cypher.spod.Username + newpopname+" ";
      Cypher.DEBUG(popnameInfo);
      DataHeader popHeader = new DataHeader(C_USER_PUT, U_POPNAME, Cypher.spod.Username.length(), newpopname.length(), popnameInfo.length());
      popHeader.send(Cypher.out);
      Cypher.out.writeBytes(popnameInfo);
      Cypher.out.flush();
    }
    catch (IOException ePopname) {
      Cypher.DEBUG(ePopname);
      Cypher.DEBUG("I/O error whilst changing popname");
    }
    catch (Exception eGeneral) {
      Cypher.DEBUG(eGeneral);
      Cypher.DEBUG("General error whilst changing popname.");
    }
  }

  /*----------------------------------------------------------------------------}
  {- Stopped this being inline in case statement on Thursday 19/04/2001 so can 
  {- call it from Cypher.java when starting. Also better in long run.
  {- Then ripped it out for the GUI client minutes later. :)
  {----------------------------------------------------------------------------*/
  public static void goAFK()
  {
    if (Cypher.AFK==0) {
      Cypher.AFK=1;
      System.out.println("You are now AWAY");
      Cypher.DEBUG("You have become AFK");
    } else {
      Cypher.AFK=0;
      System.out.println("You are now BACK!");
      Cypher.DEBUG("You are no longer AFK");
    }
  }

  /*----------------------------------------------------------------------------}
  {- get the user number to zap, and zap them!
  {----------------------------------------------------------------------------*/
  public static void doZap(String username)
  {
    try {
      int zapUser = -1;
      if ((zapUser = Utils.NameToID(username))!=-1){
        DataHeader zapHeader = new DataHeader(C_USER_ZAP, 0, 0, zapUser, 0);
        zapHeader.send(Cypher.out);
      }
    }
    catch (IOException eZap) {
      Cypher.DEBUG("Error whilst trying to zap someone! "+eZap);
    }
  }

  /*----------------------------------------------------------------------------}
  {- code for going ultra-invis.
  {----------------------------------------------------------------------------*/
  public static void goUltraInvis(int conn, int ultra)
  {
/*    DataHeader ultraHeader;
    int invis=0;
    for (int i=0; i<Cypher.userList.size(); i++){
      NewSpod thisUser=(NewSpod)Cypher.userList.elementAt(i);
      if (thisUser.ConID==conn)
        if (thisUser.isInvis()) invis = 1; else invis = 0;
    }
    try {
      ultraHeader = new DataHeader(C_STATUS_SET, conn, invis, ultra, 0);
      ultraHeader.send(Cypher.out);

      if (conn==Cypher.spod.ConnectionNum) {
        if (ultra==0) {
          Cypher.spod.Ultra=false;
          mainFrame.bUltra.setSelected(false);
        }
        else {
          Cypher.spod.Ultra = true;
          mainFrame.bUltra.setSelected(true);
        }
      }
    }
    catch (IOException eUltra) {
      Cypher.DEBUG(eUltra);
      Cypher.DEBUG("error whilst going Ultra-Invisible/Visible.");
    }  */
  }


  /*----------------------------------------------------------------------------}
  {- get the user to bmail, get the message, then send them!
  {- THIS DOESN'T WORK. (i wouldn't think)
  {----------------------------------------------------------------------------*/
  public static void bMail(String username, String message)
  {
    try {
        DataHeader bmailHeader = new DataHeader(C_MAIL_SEND, username.length(),0,0,username.length()+message.length());
        bmailHeader.send(Cypher.out);
        Cypher.out.writeBytes(username);
        Cypher.out.writeBytes(message);
        // can those two be sent as one? they might as well be.
      }
    catch (IOException eBMail) {
      Cypher.DEBUG("I/O error whilst sending a BMail. "+eBMail);
    }
  }

} // end class