/* part of the Cypher program, a java client for babel.
 *
 * functions in this file are as follows:
 *
 *   -  doLogin(String, String)
 *   -  padIt(String)
 *
 */ 

package cypher;

import java.io.*;
import java.net.*;

class Login implements Constants
{
  /*
   * this is the function which actually logs a user in.
   * it puts the username and password into the dataheader and sends them off to the server
   * it also confirms the login by checking the server return.
   * 
   */
  public static int doLogin(String username, String password)
  {
    username=Utils.padIt(username);
    password=Utils.padIt(password);
    String loginInfo = username+password+VERSION_INFO;
    try  {
      DataHeader loginHeader = new DataHeader(C_LOGIN, 0, 0, 0, loginInfo.length());
      loginHeader.send(Cypher.out);
      Cypher.out.writeBytes(loginInfo);
      Cypher.out.flush();
      return 0; 
    }
    catch (Exception e) {
      Cypher.DEBUG("Error sending login information. Warning the user...");
    }
  return 1;
  } // end doLogin

} // end Login class