package cypher;
/*
 * everyone else - how each user is represented on the userlist.
 * should really write a whole load of getXXX() methods to access NewSpod
 * attributes.
 */


import java.io.*;

public class NewSpod implements Constants
{
  // what comes in from the server
  public String Username;
  public String Popname;
  public static int Privs;
  public int ConID;
  public String IPAddress;
  public String Cookie;
  public int UserID;
  //public String padding;

  public NewSpod()
  {
    this.Username = null;
    this.Popname = null;
    this.Privs = -1;
    this.ConID = -1;
    this.IPAddress = null;
    this.Cookie = null;
    this.UserID = -1;
  }

  public NewSpod (NewSpod nS)
  {
    this.Username = nS.Username;
    this.Popname = nS.Popname;
    this.Privs = nS.Privs;
    this.ConID = nS.ConID;
    this.IPAddress = nS.IPAddress;
    this.Cookie = nS.Cookie;
    this.UserID = nS.UserID;
  }

  // a translate function
  public NewSpod translate(byte[] uListEntry, int userNum)
  {
    try {
      NewSpod spod = new NewSpod();

      DataInputStream ulEntry = new DataInputStream(new ByteArrayInputStream(uListEntry));
      ulEntry.skip(userNum*154);
      spod.Username = Utils.makeString(ulEntry, 16);
      spod.Popname = Utils.makeString(ulEntry, 64);
      spod.Privs = ulEntry.readInt();
      spod.ConID = (int)ulEntry.readShort();
      spod.IPAddress = Utils.makeString(ulEntry, 16);
      spod.Cookie = Utils.makeString(ulEntry, 16);
      spod.UserID = ulEntry.readInt();
      ulEntry.skipBytes(32);
      return spod;
    }
    catch (IOException eULEntry)
    {
      Cypher.DEBUG("error in decoding userlist entry");
      Cypher.DEBUG(eULEntry);
      return null;
    } 
  }
  
  public static boolean isAuthor()
  {
    return Utils.is(Privs,S_AUTHOR);
  }
  
  public boolean isExec()
  {
    return Utils.is(Privs,S_EXEC);
  }

  public boolean isSysop()
  {
    boolean sysop=Utils.is(Privs,S_EXECBM);
    boolean sysAdmin=Utils.is(Privs,S_BM);
    boolean author=Utils.is(Privs,S_AUTHOR);
    return (sysop|sysAdmin|author);
  }

  public boolean hasBMFlag()
  {
    return Utils.is(Privs,S_EXECBM);
  }
	
  public boolean isSysAdmin()
  {
    boolean sysAdmin=Utils.is(Privs,S_EXECBM);
    boolean author=Utils.is(Privs,S_AUTHOR);
    return (sysAdmin|author);
  }

  public boolean isInvis()
  {
    //return Utils.is(Privs, S_INVIS_LOGIN);
    return Utils.isI(Privs);
  }
	
  public boolean isUltraInvis()
  {
    //return Utils.is(Privs, S_ULTRAINVIS_LOGIN);
    return Utils.isUI(Privs);
  }  

}