package cypher;
/*
 * the user running the client. YOU! the person running this! NO ONE ELSE!
 *
 */

import java.util.Date;
import java.io.*;

public class User implements Constants
{
  // stuff normally accessible from the client
  public String Username;
  public String Password;
  public String Popname;
  public String Status;
  public String RealName;
  public String City;
  public String SysComment;
  public String EmailAddress;
  public int ConnectionNum; //added 16/03/2001 for ease in other places - not stored on server (duh).
  public String Cookie;     //added 31/03/2001 again, for ease and to reduce overhead in other places.
//  public static boolean Invis;         //added 13/04/2001 - because i want all user details in one place.
//  public static boolean Ultra;         //added 13/04/2001 - because i want all user details in one place.

  // things that we can get?
  public Date Created;
  public Date LastOn;
  public Date BannedUntil;
  public int ID;
  public int Privs;
  public int ShowDetails;
  public int LongestTimeOn;
  public int LongestTimeOnThisLeague;

  // create a new spod.
  public User() {
    //  Populate some fields
    this.Username = null;
    this.Popname = null;
    this.Privs = 0;
    this.LastOn = null;
    this.Created = null;
    this.EmailAddress = null;
//    this.Ultra = false;
//    this.Invis = false;
    }

  // receive the user's profile as a byte array and convert it to understandable stuff.
  public User translate(byte[] bUser) {
    try
    {
      User spod = new User();

      //byte[] packet = new byte[0];

      DataInputStream userIn = new DataInputStream(new ByteArrayInputStream(bUser));

      // get the profile
      spod.ID = userIn.readInt();
      spod.Created   =   Utils.makeDate(userIn);
      spod.LastOn    =   Utils.makeDate(userIn);
      spod.Username  =   Utils.makeString(userIn,W_USERNAME);
      spod.Password  =   Utils.makeString(userIn,W_PASSWORD);
      spod.EmailAddress= Utils.makeString(userIn,W_EMAIL);
      spod.Privs     =   userIn.readInt();
      spod.BannedUntil = Utils.makeDate(userIn);          
      spod.ShowDetails = userIn.readInt();
      spod.Popname   =   Utils.makeString(userIn,W_MOTTO);
      spod.RealName  =   Utils.makeString(userIn,W_REALNAME);
      spod.City      =   Utils.makeString(userIn,W_CITY);
      spod.SysComment =  Utils.makeString(userIn,W_COMMENT);
      userIn.skip(5); // Control (1 byte plus prevpostings int)
      spod.Status    =   Utils.makeString(userIn,1);
      // check the privs to see if should be invis/ultra-invis?
      // spod.Invis =
      // spod.Ultra =
      return spod;
    }
    catch (IOException e)
    {
      Cypher.DEBUG("error in decoding person details");
      Cypher.DEBUG(e);
      return null;
    } 
  } // end User.transalte()

}
