package cypher;
/*----------------------------------------------------------------------------}
{-some general functions for use here and there in Cypher.
{-
{-containing: IDToName(int userID)
{-            NameToID(String uName)
{-            makeString(DataInputStream byteStream, int pLen) throws IOException
{-            makeDate(DataInputStream byteStream, int pLen) throws IOException
getDate
getMarker
{----------------------------------------------------------------------------*/

import java.io.*;
import java.util.*;
import javax.swing.JLabel;
import java.awt.Color;

class Utils implements Constants
{

  /*
   * quick function just to pad the fields to 16 to make the server happy.
   * used for login (and listusers display (temp?))
   */
  public static String padIt(String word)
  {
    if (word=="") word="Guest";
    else if (word.length() > 16) return word.substring(0,16);
    for(; word.length() < 16; word = word + " ");
    return word;
  } //end padIt

 /*----------------------------------------------------------------------------}
 {- quick and simple function to return the username of a user, given their
 {- connection number.
 {----------------------------------------------------------------------------*/
  public static String IDToName(int userID)
  {
    NewSpod xTarget = new NewSpod();
    for (int x=0; x < Cypher.userList.size(); x++) {
      xTarget = (NewSpod)Cypher.userList.elementAt(x);
      if (userID==xTarget.ConID) {
        return xTarget.Username;
      }
    }
    Cypher.DEBUG("Unable to translate ID number to a username.");
    return null;
  }

  /*----------------------------------------------------------------------------}
  {- take the name, loop through the userlist vector, find the name, and
  {- return the relevant ID. :)
  {----------------------------------------------------------------------------*/
  public static int NameToID(String uName)
  {
    NewSpod xTarget = new NewSpod();
    for (int x=0; x < Cypher.userList.size(); x++) { //loop through the vector userlist
      xTarget = (NewSpod)Cypher.userList.elementAt(x);
      if (uName.equalsIgnoreCase(xTarget.Username)==true) {
        return xTarget.ConID;
      }
    }
    Cypher.DEBUG("Unable to translate USERNAME ("+uName+") to Connection Number");
    return -1;
  }

  /*----------------------------------------------------------------------------}
  {- Creates a string from the passed in stream
  {- declare a byte array, set it to the length of the stream to convert
  {- typecast it and return.
  {----------------------------------------------------------------------------*/
  public static String makeString(DataInputStream byteStream, int pLen) throws IOException
  {
      byte[] temp;                       
      temp = new byte[pLen];
      byteStream.read(temp);
      return new String(temp).trim();
  } 

  /*----------------------------------------------------------------------------}
  {-This will read a legacy date off the passed in stream
  {----------------------------------------------------------------------------*/
  public static Date makeDate(DataInputStream pByteStream) throws IOException
  {
    //TODO: We aren't creating a date here, just skipping the 8 bytes
    pByteStream.skip(8);
    return new Date();
  }

  /*----------------------------------------------------------------------------}
  {-Get the current time and date for output to the DEBUG file.
  {----------------------------------------------------------------------------*/
  public static String getDate()
  {
    Calendar calendar = new GregorianCalendar();
    String dateAndTime = new String(calendar.get(Calendar.DATE) + "/"
                              + calendar.get(Calendar.MONTH) + "/"
                              + calendar.get(Calendar.YEAR) + " - "
                              + calendar.get(Calendar.HOUR_OF_DAY) + ":"
                              + calendar.get(Calendar.MINUTE) + ":"
                              + calendar.get(Calendar.SECOND));
    return dateAndTime;
  }

  /*----------------------------------------------------------------------------}
  {- quick and dirty. and crap.
  {- returns a marker for the userlist based on privs/visibility
  {- used in command line client, but still here. :)
  {----------------------------------------------------------------------------*/
  public static String getMarker(int iPrivs)
  {
	String marker;
    marker = "?";
    if (iPrivs >= S_AUTHOR) {
		iPrivs = iPrivs - S_AUTHOR - S_REGISTERED;
        marker = "*";
	} else if (iPrivs >= S_EXECBM) {
		iPrivs = iPrivs - S_EXECBM - S_REGISTERED;
        marker = "^";
	} else if (iPrivs >= S_BM) {
		iPrivs = iPrivs - S_BM - S_REGISTERED;
        marker = "#";
	} else if (iPrivs >= S_GUIDE) {
		iPrivs = iPrivs - S_GUIDE - S_REGISTERED;
        marker = "G";
	} else if (iPrivs >= S_REGISTERED) {
		iPrivs = iPrivs - S_REGISTERED;
        marker = "-";
	}
	if (iPrivs >= S_ULTRAINVIS_LOGIN) {
		iPrivs = iPrivs - S_ULTRAINVIS_LOGIN;
        marker = "u";
	}
	if (iPrivs >= S_INVIS_LOGIN) {
		iPrivs = iPrivs - S_INVIS_LOGIN;
        if (marker!="u") marker = "i";
	}
    return marker;
  }

  public static boolean isI(int privs)
  {
    if (privs >= S_AUTHOR) {
		privs = privs - S_AUTHOR - S_REGISTERED;
	} else if (privs >= S_EXECBM) {
		privs = privs - S_EXECBM - S_REGISTERED;
	} else if (privs >= S_BM) {
		privs = privs - S_BM - S_REGISTERED;
	} else if (privs >= S_GUIDE) {
		privs = privs - S_GUIDE - S_REGISTERED;
	} else if (privs >= S_REGISTERED) {
		privs = privs - S_REGISTERED;	
	}
	if (privs >= S_ULTRAINVIS_LOGIN) {
		privs = privs - S_ULTRAINVIS_LOGIN;
	}  
	if (privs >= S_INVIS_LOGIN) {
        return true;
	}
    else return false;
  }

  public static boolean isUI(int privs)
  {
    if (privs >= S_AUTHOR) {
		privs = privs - S_AUTHOR - S_REGISTERED;
	} else if (privs >= S_EXECBM) {
		privs = privs - S_EXECBM - S_REGISTERED;
	} else if (privs >= S_BM) {
		privs = privs - S_BM - S_REGISTERED;
	} else if (privs >= S_GUIDE) {
		privs = privs - S_GUIDE - S_REGISTERED;
	} else if (privs >= S_REGISTERED) {
		privs = privs - S_REGISTERED;	
	}
	if (privs >= S_ULTRAINVIS_LOGIN) {
        return true;
	}  
    return false;;
  }

  public static boolean is(int privs,int mask)
  {
    boolean ret=false;
    if ((privs & mask) == mask)
      ret=true;
    return ret;
  }

  public static boolean isGuest()
  {
    return (Cypher.spod.Username.equals("Guest"));
  }

  public static void setYes(JLabel label, Color col)
  {
    label.setForeground(col);
    label.setText("YES");
  }

  public static void setNo(JLabel label, Color col)
  {
    label.setForeground(col);
    label.setText("NO");
  }


}//end Utils
